/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * Osoyoo W5100 web server lesson 7
 * Remote control a servo through internet
 * tutorial url: https://osoyoo.com/?p=10000
 */

#include <Servo.h> 
#define servo_pin 4
Servo servo_obj;  // create servo object to control a servo 
#include <SPI.h>          // needed for Arduino versions later than 0018
#include <Ethernet.h>
#include <EthernetUdp.h>  // UDP library from: bjoern@cs.stanford.edu 12/30/2008


// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {   0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
 

unsigned int localPort = 8888;              // local port to listen on

// buffers for receiving and sending data
char packetBuffer[UDP_TX_PACKET_MAX_SIZE];  //buffer to hold incoming packet,
char  ReplyBuffer[] = "acknowledged";       // a string to send back

// An EthernetUDP instance to let us send and receive packets over UDP
EthernetUDP Udp;

void setup() {
  Serial.begin(9600);
  servo_obj.attach(servo_pin);
  // start the Ethernet and UDP:
  Ethernet.begin(mac);

  Udp.begin(localPort);

    Serial.print("Your Arduino IP address is ");
  Serial.println(Ethernet.localIP());
 
}
int getAngle()
{
   int angle=0;
   for (int i=0;i<4;i++) {
    if (packetBuffer[i]<'0' || packetBuffer[i]>'9') break;
    angle=angle*10+(int)(packetBuffer[i]-'0');
   }
   if (angle>360) angle=360;
   return angle;
}
void loop() {
  // if there's data available, read a packet
  int packetSize = Udp.parsePacket();
  if(packetSize)
  {
    Serial.print("Received packet of size ");
    Serial.println(packetSize);
    Serial.print("From ");
    IPAddress remote = Udp.remoteIP();
    for (int i =0; i < 4; i++)
    {
      Serial.print(remote[i], DEC);
      if (i < 3)
      {
        Serial.print(".");
      }
    }
    Serial.print(", port ");
    Serial.println(Udp.remotePort());

    // read the packet into packetBufffer
    Udp.read(packetBuffer,UDP_TX_PACKET_MAX_SIZE);
    Serial.println("Contents:");
    int angle=getAngle();
    Serial.println(angle);
    servo_obj.write(angle);
    // send a reply, to the IP address and port that sent us the packet we received
    //Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
   // Udp.write(ReplyBuffer);
   // Udp.endPacket();
  }
  delay(10);
}
